﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Graphics.Imaging;
using Windows.Storage;
using Windows.Storage.Streams;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.Storage.Pickers;
using Windows.UI.Popups;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace InsertingImage
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private async void Button_Click_1(object sender, RoutedEventArgs e)
        {
            Assembly executingAssembly = typeof(MainPage).GetTypeInfo().Assembly;
            Stream iamgeStream = executingAssembly.GetManifestResourceStream("InsertingImage.Assets.Autumn Leaves.jpg");
            PdfImage image = PdfImage.FromStream(iamgeStream);
            PdfDocument doc = new PdfDocument();
            PdfPage page = doc.Pages.Add();
            page.Graphics.DrawImage(image, new System.Drawing.PointF(0, 0));
            MemoryStream document = new MemoryStream();
            doc.Save(document);
            Save(document,"jpeg.pdf");            
        }


        #region Helper Methods
        async void Save(Stream stream, string filename)
        {

            stream.Position = 0;

            FileSavePicker savePicker = new FileSavePicker();
            savePicker.DefaultFileExtension = ".pdf";
            savePicker.SuggestedFileName = "Sample";
            savePicker.FileTypeChoices.Add("Adobe PDF Document", new List<string>() { ".pdf" });
            StorageFile stFile = await savePicker.PickSaveFileAsync();
            if (stFile != null)
            {
                Windows.Storage.Streams.IRandomAccessStream fileStream = await stFile.OpenAsync(FileAccessMode.ReadWrite);
                Stream st = fileStream.AsStreamForWrite();
                MemoryStream memoryStream = new MemoryStream();
                stream.CopyTo(memoryStream);
                memoryStream.Position = 0;
                st.Write(memoryStream.ToArray(), 0, (int)stream.Length);
                st.Flush();
                st.Dispose();
                fileStream.Dispose();
            }

            MessageDialog msgDialog = new MessageDialog("Do you want to view the Document?", "File has been created successfully.");
            UICommand yesCmd = new UICommand("Yes");
            msgDialog.Commands.Add(yesCmd);
            UICommand noCmd = new UICommand("No");
            msgDialog.Commands.Add(noCmd);
            IUICommand cmd = await msgDialog.ShowAsync();
            if (cmd == yesCmd)
            {
                // Launch the retrieved file
                bool success = await Windows.System.Launcher.LaunchFileAsync(stFile);
            }
        }
        #endregion

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Assembly assembly = typeof(MainPage).GetTypeInfo().Assembly;

            //Getting the fontdata
            Stream fontData = assembly.GetManifestResourceStream("InsertingImage.Assets.signature.png");

            PdfDocument doc = new PdfDocument();
            PdfPage page = doc.Pages.Add();
            PdfGraphics gr = page.Graphics;
            //creating the image Async
            PdfImage image = PdfImage.FromStream(fontData); // await PdfImage.FromStreamAsync(fontData);
            gr.DrawImage(image, 0, 0, 256, 256);

            MemoryStream m = new MemoryStream();
            doc.Save(m);
            Save(m,"png.pdf");

        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            PdfDocument doc = new PdfDocument();
            PdfSection sec = doc.Sections.Add();

            Assembly assembly = typeof(MainPage).GetTypeInfo().Assembly;

            //Getting the fontdata
            Stream fontData = assembly.GetManifestResourceStream("InsertingImage.Assets.image.tiff");



            PdfBitmap img = new PdfBitmap(fontData);
            int count = img.FrameCount;
            for (int i = 0; i < count; i++)
            {

                PdfPage page = doc.Pages.Add();
                sec.PageSettings.Margins.All = 0;
                PdfGraphics g = page.Graphics;
                img.ActiveFrame = i;

                g.DrawImage(img, 0, 0, page.Size.Width, page.Size.Height);

            }
            MemoryStream m = new MemoryStream();
            doc.Save(m);
            Save(m,"tiff.pdf");
        }

    }
}
